/*
 *	x11render.c - render an Oric frame into a buffer
 *	AYM 2002-01-27
 */

/*
This file is copyright Andr Majorel 2002-2003.

This program is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published by the
Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place, Suite 330, Boston, MA 02111-1307, USA.
*/


/* This file is not supposed to be compiled directly. It is
   included from x11.c. ximage_pixel_t is typedef'd to either
   (unsigned char *), (unsigned short *) or (unsigned long *),
   depending on the depth of the XImage we're rendering onto. */


const char *b;

ximage_pixel_t *to  = (ximage_pixel_t *) img->data + 0 * width;
ximage_pixel_t *to2 = (ximage_pixel_t *) img->data + 1 * width;
ximage_pixel_t *to3 = (ximage_pixel_t *) img->data + 2 * width;

int y;

b = buf;
for (y = 0; y < VIDEO_HEIGHT; y++)
{
  const char *bmax;

  if (b[VIDEO_WIDTH])
  {
    if (y0 < 0)
      y0 = y;
    y1 = y;

    /* Render one scan line */
    if (zoom == 1)
    {
      for (bmax = b + VIDEO_WIDTH; b < bmax; b++)
      {
#ifdef USE_MEMCPY			/* Used for 24 bpp pixmap formats. */
	memcpy (to++, colours + *b, sizeof to);
#else
	*to++ = colours[*b];
#endif
      }
    }
    else if (zoom == 2)
    {
      for (bmax = b + VIDEO_WIDTH; b < bmax; b++)
      {
#ifdef USE_MEMCPY			/* Used for 24 bpp pixmap formats. */
	memcpy (to++,  colours + *b, sizeof to);
	memcpy (to++,  colours + *b, sizeof to);
	memcpy (to2++, colours + *b, sizeof to2);
	memcpy (to2++, colours + *b, sizeof to2);
#else
	*to++  = colours[*b];
	*to++  = colours[*b];
	*to2++ = colours[*b];
	*to2++ = colours[*b];
#endif
      }
      to  += width;
      to2 += width;
    }
    else if (zoom == 3)
    {
      for (bmax = b + VIDEO_WIDTH; b < bmax; b++)
      {
#ifdef USE_MEMCPY			/* Used for 24 bpp pixmap formats. */
	memcpy (to++,  colours + *b, sizeof to);
	memcpy (to++,  colours + *b, sizeof to);
	memcpy (to++,  colours + *b, sizeof to);
	memcpy (to2++, colours + *b, sizeof to2);
	memcpy (to2++, colours + *b, sizeof to2);
	memcpy (to2++, colours + *b, sizeof to2);
	memcpy (to3++, colours + *b, sizeof to3);
	memcpy (to3++, colours + *b, sizeof to3);
	memcpy (to3++, colours + *b, sizeof to3);
#else
	*to++  = colours[*b];
	*to++  = colours[*b];
	*to++  = colours[*b];
	*to2++ = colours[*b];
	*to2++ = colours[*b];
	*to2++ = colours[*b];
	*to3++ = colours[*b];
	*to3++ = colours[*b];
	*to3++ = colours[*b];
#endif
      }
      to  += 2 * width;
      to2 += 2 * width;
      to3 += 2 * width;
    }
    b++;				/* KLUDGE - skip over the boolean */
  }
  else
  {
    b += VIDEO_WIDTH + 1;		/* KLUDGE - +1 to skip over the bool */
    if (zoom == 1)
    {
      to += width;
    }
    else if (zoom == 2)
    {
      to  += 2 * width;
      to2 += 2 * width;
    }
    else if (zoom == 3)
    {
      to  += 3 * width;
      to2 += 3 * width;
      to3 += 3 * width;
    }
  }
}

/* Do the trace thing */
#if 0
{
  int n = tracehead;
  ximage_pixel_t *tomax = to + VIDEO_WIDTH;
  for (; to < tomax; to++)
  {
    if (n >= sizeof tracebuf / sizeof *tracebuf)
      n = 0;
    if (tracebuf[n])
      *to = colours[4];
    else
      *to = colours[3];
    n++;
  }
}
#endif
